/******************************************************************************
HEADER DA CLASSE ABIBLIA
CRIADO: 09-2007
ALTERADO: 07-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#ifndef ABIBLIA_H
#define ABIBLIA_H

#include <QtGui>
#include <QSplashScreen>
#include <stdlib.h>

#include "readbiblia.h"
#include "readpesquisa.h"
#include "readpassagens.h"
#include "readestudos.h"
#include "ferramentas.h"
#include "config.h"
#include "resolucao.h"
#include "atabwidget.h"

class QSpacerItem;
class QLabel;
class QTabWidget;
class QWidget;
class QComboBox;
class QPushButton;
class QLineEdit;
class QGroupBox;
class QRadioButton;
class QFont;
class QTextEdit;
class QCheckBox;
class Exportar;

class abiblia : public QMainWindow
{
    Q_OBJECT

public:
	abiblia();
	~abiblia();

	QPixmap top;
	QPixmap icon;
	QGridLayout *gbox;
	QGroupBox* gbxBox;
	
	QSplashScreen* splash;
	QWaitCondition waitC;
	QMutex mutex;
	
	QWidget* wgtPromessas;
	ATabWidget* aTabWidget;
	QAction* actFecharAba;
	QToolButton *btnFecharAba;

	//Menus
	QAction* actListarAnotacoes;
	QAction* actFecharTodasAbas;
	QAction* actSair;
	QAction* actConfiguracoes;
	QAction* actMudarResolucao;
	QAction* actVerificarAtualizacoes;
	QAction* actSobreaBiblia;
	QAction* actSobreQt;
	QAction* actChamarFrmBiblia;
	QAction* actChamarFrmPesquisa;
	QAction* actChamarFrmPassagens;
	QAction* actChamarFrmEstudos;
	QAction* actNovaPromessa;
	QMenu* mnuAplicacao;
	QMenu* mnuOpcoes;
	QMenu* mnuAjuda;

	//Metdos normais
	void resizeEvent(QResizeEvent* /*event*/);
	void closeEvent(QCloseEvent *event);

private:
	Config config;
	Ferramentas ferramentas;
	Resolucao resolucao;
	QLabel lblPromessa;
	void carregarSplash();
	void recuperarEstadoAbas();
	void gravarEstadoAbas();
	void carregarResolucao();

private slots:
	//Menus
	void chamarSobre();
	void chamarSobreQt();
	void chamarAbrirAnot();
	void chamarAtualizador();
	void chamarMudarResolucao();
	void chamarConfigurarTextos();
	void chamarFrmBiblia();
	void chamarFrmPesquisa();
	void chamarFrmPassagens();
	void chamarFrmEstudos();
	void chamarNovaPromessa();
	void slotGerarAbas(ReadBiblia* read);
	void slotGerarAbas(ReadEstudos* read);
	void slotGerarAbas(ReadPesquisa* read);
	void slotGerarAbas(ReadPassagens* read);
	void slotFecharEstudos(const QString &strCategoria, const QString &strTitulo);
	void slotFecharTodasAbas();
};

#endif

