/******************************************************************************
CLASSE BANCOUSER
CRIADO: 28-05-2008
ALTERADO: 17-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "bancouser.h"

#include "amessagebox.h"

BancoUser::BancoUser():QObject(){
	if (!QSqlDatabase::contains("qt_sql_default_connection")){
		db = QSqlDatabase::addDatabase("QSQLITE"); 
		db.setHostName("localhost");
		db.setDatabaseName(DIR_PATH + "userData.db");
		if (db.drivers().isEmpty()){
			AMessageBox aMsgBox;
			#if defined(__linux__)
				aMsgBox.ok("No foi possvel carregar a Biblioteca libqt4-sql-sqlite!", "Driver no carregado");
			#elif defined(_WIN32) || defined(__WIN32) || defined(WIN32) || defined(__WIN32__)
				aMsgBox.ok("No foi possvel carregar a Biblioteca sqldrivers/qsqlite4.dll!", "Driver no carregado");
			#endif
		}
		db.open();
	}
	
	_criarTabelas();
}
void BancoUser::_criarTabelas(){
	QSqlQuery query;
	//Estudos
	query.exec("CREATE TABLE estudos(categoria varchar(128), titulo varchar(256), "
	"conteudo varchar, autor varchar(128), data varchar(15), revisor varchar, "
	"datar varchar(15));");
	//Anotaes
	query.exec("CREATE TABLE anotacoes(livro varchar(30), capitulo varchar(5), conteudo varchar);");
	//Estado Abas
	query.exec("CREATE TABLE estadoAbas(id int, tipo varchar, texto1 varchar, texto2 varchar, texto3 varchar, numerico1 int, numerico2 int);");
}

/****************************************************************************************************************************
ESTUDOS
****************************************************************************************************************************/
bool BancoUser::existEstudo(const QString &categoria, const QString &titulo){
	QString compare;
	QSqlQuery query;
	query.exec("SELECT titulo FROM estudos WHERE categoria = '" + categoria + 
	"' AND titulo = '" + titulo + "'"); 
	while (query.next()) {
		compare += query.value(0).toString();
	}
	if (compare == titulo)
		return true;

	return false;
}
QString BancoUser::getConteudoEstudo(const QString &categoria, const QString &titulo){
	QString retorno;
	QSqlQuery query;
	query.exec("SELECT conteudo FROM estudos WHERE categoria = '" + categoria + 
	"' AND titulo = '" + titulo + "'"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
}
QString BancoUser::getAutorEstudo(const QString &categoria, const QString &titulo){
	QString retorno;
	QSqlQuery query;
	query.exec("SELECT autor FROM estudos WHERE categoria = '" + categoria + 
	"' AND titulo = '" + titulo + "'"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
}
QString BancoUser::getDataEstudo(const QString &categoria, const QString &titulo){
	QString retorno;
	QSqlQuery query;
	query.exec("SELECT data FROM estudos WHERE categoria = '" + categoria + 
	"' AND titulo = '" + titulo + "'"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
}
QString BancoUser::getRevisorEstudo(const QString &categoria, const QString &titulo){
	QString retorno;
	QSqlQuery query;
	query.exec("SELECT revisor FROM estudos WHERE categoria = '" + categoria + 
	"' AND titulo = '" + titulo + "'"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
} 
QString BancoUser::getDataRevisaoEstudo(const QString &categoria, const QString &titulo){
	QString retorno;
	QSqlQuery query;
	query.exec("SELECT datar FROM estudos WHERE categoria = '" + categoria + 
	"' AND titulo = '" + titulo + "'"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
}
QStringList BancoUser::getCategoriasEstudo(){
	QStringList retorno;
	QSqlQuery query;
	query.exec("SELECT DISTINCT categoria FROM estudos ORDER BY categoria");
	while (query.next()){
   		retorno << query.value(0).toString();
	} 
	return retorno;
}
QStringList BancoUser::getTitulosEstudo(const QString &categoria){
	QStringList retorno;
	QSqlQuery query;
	query.exec("SELECT DISTINCT titulo FROM estudos WHERE categoria = '" + categoria +
		"'ORDER BY titulo");
	while (query.next()){
		retorno << query.value(0).toString();
	} 
	return retorno;
}
void BancoUser::setEstudo(const QString &categoria, const QString &titulo, 
						const QString &conteudo, const QString &autor, 
						const QString &data, const QString &revisor, 
						const QString &datar){
	QSqlQuery query;
	query.prepare("INSERT INTO estudos(categoria, titulo, conteudo, autor, data, revisor, datar) "
	"VALUES (?, ?, ?, ?, ?, ?, ?)");
	query.addBindValue(categoria);
	query.addBindValue(titulo);
	query.addBindValue(conteudo);
	query.addBindValue(autor);
	query.addBindValue(data);
	query.addBindValue(revisor);
	query.addBindValue(datar);
	query.exec();
}
void BancoUser::editEstudo(const QString &categoriaAntiga, const QString &tituloAntigo,
						const QString &categoria, const QString &titulo, 
						const QString &conteudo, const QString &autor, 
						const QString &data, const QString &revisor, 
						const QString &datar){
	QSqlQuery query;
	query.exec("UPDATE estudos SET categoria = '" + categoria + 
	"', titulo = '" + titulo + "', conteudo = '" + conteudo +
	"', autor = '" + autor + "', data = '" + data +
	"', revisor = '" + revisor + "', datar = '" + datar +
	"' WHERE categoria = '" + categoriaAntiga + 
	"' AND titulo = '" + tituloAntigo + "'"); 
}
void BancoUser::delEstudo(const QString &categoria, const QString &titulo){
	QSqlQuery query;
	if (categoria.trimmed().isEmpty() && titulo.trimmed().isEmpty()){
		query.exec("DROP TABLE estudos");
		_criarTabelas();
	}
	else
		query.exec("DELETE FROM estudos WHERE categoria = '" + categoria + 
		"' AND titulo = '" + titulo + "'");
}
/****************************************************************************************************************************
ANOTAES
****************************************************************************************************************************/
bool BancoUser::existAnotacao(const QString &livro, const QString &capitulo){
	QString compare;
	QSqlQuery query;
	query.exec("SELECT capitulo FROM anotacoes WHERE conteudo <> '' AND livro = '" + livro + 
		"' AND capitulo = '" + capitulo + "'");
	while (query.next()) {
		compare += query.value(0).toString();
	}
	if (compare == capitulo)
		return true;
	return false;
}
QString BancoUser::getAnotacao(const QString &livro, const QString &capitulo){
	QString retorno;
	QSqlQuery query;
	query.exec("SELECT conteudo FROM anotacoes WHERE livro = '" + livro + 
		"' AND capitulo = '" + capitulo + "'"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
}
QStringList BancoUser::getListLivroAnotacao(){
	QStringList retorno;
	QSqlQuery query;
	query.exec("SELECT DISTINCT livro FROM anotacoes WHERE conteudo <> '' ORDER BY livro"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
}
QStringList BancoUser::getListCapituloAnotacao(const QString &livro){
	QStringList retorno;
	QSqlQuery query;
	query.exec("SELECT capitulo FROM anotacoes WHERE  conteudo <> '' AND livro = '" + livro + 
		"' ORDER BY capitulo"); 
	while (query.next()) {
		retorno += query.value(0).toString();
	}
	return retorno;
}
void BancoUser::editAnotacao(const QString &livro, const QString &capitulo, const QString &conteudo){
	QString _conteudo;
	if (conteudo.trimmed() == "")
		_conteudo = "";
	else
		_conteudo = conteudo;
	
	QSqlQuery query;
	query.exec("UPDATE anotacoes SET livro = '" + livro + 
		"', capitulo = '" + capitulo + "', conteudo = '" + _conteudo + 
		"' WHERE livro = '" + livro + "' AND capitulo = '" + capitulo + "'"); 
}
void BancoUser::setAnotacao(const QString &livro, const QString &capitulo, const QString &conteudo){
	QString _conteudo;
	if (conteudo.trimmed() == "")
		_conteudo = "";
	else
		_conteudo = conteudo;
		
	QSqlQuery query;
	query.prepare("INSERT INTO anotacoes(livro, capitulo, conteudo) "
		"VALUES (?, ?, ?)");
	query.addBindValue(livro);
	query.addBindValue(capitulo);
	query.addBindValue(_conteudo);
	query.exec();
}
void BancoUser::delAnotacao(const QString &livro, const QString &capitulo){
	QSqlQuery query;
	query.exec("DELETE FROM anotacoes WHERE livro = '" + livro + 
		"' AND capitulo = '" + capitulo + "'");
}
/****************************************************************************************************************************
ESTADO ABAS
****************************************************************************************************************************/
void BancoUser::setEstadoAbas(int id, QString tipo, QString texto1, QString texto2, QString texto3, int numerico1, int numerico2){
	QSqlQuery query;
	query.exec("CREATE TABLE estadoAbas(id int, tipo varchar, texto1 varchar, texto2 varchar, texto3 varchar, numerico1 int, numerico2 int);");
	
	query.prepare("INSERT INTO estadoAbas(id, tipo, texto1, texto2, texto3, numerico1, numerico2) "
		"VALUES (?, ?, ?, ?, ?, ?, ?)");
	query.addBindValue(id);
	query.addBindValue(tipo);
	query.addBindValue(texto1);
	query.addBindValue(texto2);
	query.addBindValue(texto3);
	query.addBindValue(numerico1);
	query.addBindValue(numerico2);
	query.exec();
}
QStringList BancoUser::getEstadoAbas(int id){
	QStringList retorno;
	QVariant v;
	v.setValue(id);
	QString strId = v.toString();
	
	QSqlQuery query;
	query.exec("SELECT tipo FROM estadoAbas WHERE id = "+ strId +" ORDER BY id"); 
	while (query.next()) {
		retorno << query.value(0).toString();
	}
	query.exec("SELECT texto1 FROM estadoAbas WHERE id = "+ strId +" ORDER BY id"); 
	while (query.next()) {
		retorno << query.value(0).toString();
	}
	query.exec("SELECT texto2 FROM estadoAbas WHERE id = "+ strId +" ORDER BY id"); 
	while (query.next()) {
		retorno << query.value(0).toString();
	}
	query.exec("SELECT texto3 FROM estadoAbas WHERE id = "+ strId +" ORDER BY id"); 
	while (query.next()) {
		retorno << query.value(0).toString();
	}
	query.exec("SELECT numerico1 FROM estadoAbas WHERE id = "+ strId +" ORDER BY id"); 
	while (query.next()) {
		retorno << query.value(0).toString();
	}
	query.exec("SELECT numerico2 FROM estadoAbas WHERE id = "+ strId +" ORDER BY id"); 
	while (query.next()) {
		retorno << query.value(0).toString();
	}
	
	return retorno;
}
void BancoUser::delEstadoAbas(){
	QSqlQuery query;
	query.exec("DROP TABLE estadoAbas"); 
}
int BancoUser::maxEstadoAbas(){
	QSqlQuery query;
	query.exec("SELECT MAX(id) FROM estadoAbas"); 
	while (query.next()) {
		return query.value(0).toInt();
	}
	return 0;
}

void BancoUser::openDb(){
	db.open();
}
void BancoUser::closeDb(){
	db.close();
}
BancoUser::~BancoUser(){
}

