/******************************************************************************
METODO DA CLASSE READ (CLASSE PAI)
CRIADO: 28-05-2008
ALTERADO: 30-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#ifndef READ_H
#define READ_H

#include <QtGui>
#include <string.h>

#include "const.h"
#include "config.h"
#include "resolucao.h"
#include "afullscreen.h"

class QPixmap;
class QLabel;
class QFont;
class QTextEdit;
class QPushButton;
class QTextDocument;

class Read : public QMainWindow
{
	Q_OBJECT

public:
	Read();
	~Read();

	//Logo top
	QPixmap top;
	QPixmap icon;

	//Menus
	QAction *aumentarFonte;
	QAction *diminuirFonte;
	QAction *actFontePadrao;
	QAction *actProcurarToken;
	QAction *exibirTelaInteira;
	QAction *imprimir;
	QAction *sair;
	QMenu *arquivoMenu;
	QMenu *exibirMenu;
	//QLineEdit* ledProcurar;

	//Endereo web
	QLabel *comunidade;

	//Caixa de texto
	QFont fonte;
	QTextBrowser *caixaTexto;

	Resolucao resolucao;
	Config config;
	bool getSalvo();
	void setSalvo(bool s);
	AFullScreen* fullScreen;

private:
	unsigned short int widthOld;
	unsigned short int heightOld;
	bool _salvo;

public slots:
	void slotImprimir(){
		QPrinter *printer = new QPrinter( QPrinter::HighResolution );
		QTextDocument *texto = caixaTexto->document();
		QPrintDialog telaImprimir(printer,this);
		if(telaImprimir.exec())
			texto->print(printer);
	}
	void slotTelaInteira();
	//void slotExibirProcurarToken();
	//void procurarToken();
signals:
	void salvarTexto();
	void tituloAlterado(const QString &strTitulo);
	void finalizado();

};
#endif

