/******************************************************************************
CLASSE WIDGETEDITOR
CRIADO: 20-01-2009
ALTERADO: 20-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "widgeteditor.h"
#include "ferramentas.h"
#include "readbiblia.h"


WidgetEditor::WidgetEditor():QWidget(){
	QPixmap icon;
	icon.load((const QString&)DIR_ICONS+ "icon.png");	
	setWindowIcon(icon);
	setWindowTitle("Formatar");

	QGroupBox* gbxBox = new QGroupBox(this);
	gbxBox->setToolTip("F10 para exibir/ocultar\neste controle");
	gbxBox->setGeometry( 5, 5, 250, 130 );

	QPushButton* btnBold = new QPushButton(gbxBox);
	btnBold->setShortcut(Qt::CTRL + Qt::Key_B);
	icon.load((const QString&)DIR_ICONS + "bold.png");
	btnBold->setIcon(icon);
	btnBold->setToolTip("Negrito");
	btnBold->setGeometry( 10, 10, 30, 30 );
	
	QPushButton* btnItalic = new QPushButton(gbxBox);
	btnItalic->setShortcut(Qt::CTRL + Qt::Key_I);
	icon.load((const QString&)DIR_ICONS + "italic.png");
	btnItalic->setIcon(icon);
	btnItalic->setToolTip("Itlico");
	btnItalic->setGeometry( 50, 10, 30, 30 );

	QPushButton* btnUnderline = new QPushButton(gbxBox);
	btnUnderline->setShortcut(Qt::CTRL + Qt::Key_U);
	icon.load((const QString&)DIR_ICONS + "underline.png");
	btnUnderline->setIcon(icon);
	btnUnderline->setToolTip("Sublinhado");
	btnUnderline->setGeometry( 90, 10, 30, 30 );

	QPushButton* btnLeft = new QPushButton(gbxBox);
	btnLeft->setShortcut(Qt::CTRL + Qt::Key_L);
	icon.load((const QString&)DIR_ICONS + "justifyleft.png");
	btnLeft->setIcon(icon);
	btnLeft->setToolTip("Alinhar  esquerda");
	btnLeft->setGeometry( 130, 10, 30, 30 );

	QPushButton* btnCenter = new QPushButton(gbxBox);
	btnCenter->setShortcut(Qt::CTRL + Qt::Key_L);
	icon.load((const QString&)DIR_ICONS + "justifycenter.png");
	btnCenter->setIcon(icon);
	btnCenter->setToolTip("Centralizado");
	btnCenter->setGeometry( 170, 10, 30, 30 );
	
	QPushButton* btnRight = new QPushButton(gbxBox);
	btnRight->setShortcut(Qt::CTRL + Qt::Key_L);
	icon.load((const QString&)DIR_ICONS + "justifyright.png");
	btnRight->setIcon(icon);
	btnRight->setToolTip("Alinhar  direita");
	btnRight->setGeometry( 210, 10, 30, 30 );

	QPushButton* btnColor = new QPushButton(gbxBox);
	btnColor->setShortcut(Qt::CTRL + Qt::Key_1);
	icon.load((const QString&)DIR_ICONS + "forecolor.png");
	btnColor->setIcon(icon);
	btnColor->setToolTip("Cor da fonte");
	btnColor->setGeometry( 10, 50, 30, 30 );

	QPushButton* btnBlockQuote = new QPushButton(gbxBox);
	btnBlockQuote->setShortcut(Qt::CTRL + Qt::Key_1);
	icon.load((const QString&)DIR_ICONS + "indent.png");
	btnBlockQuote->setIcon(icon);
	btnBlockQuote->setToolTip("Aumentar recuo");
	btnBlockQuote->setGeometry( 50, 50, 30, 30 );

	QPushButton* btnBList = new QPushButton(gbxBox);
	btnBList->setShortcut(Qt::CTRL + Qt::Key_1);
	icon.load((const QString&)DIR_ICONS + "bullist.png");
	btnBList->setIcon(icon);
	btnBList->setToolTip("Lista com marcador");
	btnBList->setGeometry( 90, 50, 30, 30 );

	QPushButton* btnOList = new QPushButton(gbxBox);
	btnOList->setShortcut(Qt::CTRL + Qt::Key_1);
	icon.load((const QString&)DIR_ICONS + "numlist.png");
	btnOList->setIcon(icon);
	btnOList->setToolTip("Lista com numerao");
	btnOList->setGeometry( 130, 50, 30, 30 );

	QPushButton* btnClear = new QPushButton(gbxBox);
	btnClear->setShortcut(Qt::CTRL + Qt::Key_1);
	icon.load((const QString&)DIR_ICONS + "nocode.png");
	btnClear->setIcon(icon);
	btnClear->setToolTip("Limpar formatao");
	btnClear->setGeometry( 170, 50, 30, 30 );

	QPushButton* btnUrl = new QPushButton(gbxBox);
	btnUrl->setShortcut(Qt::CTRL + Qt::Key_1);
	icon.load((const QString&)DIR_ICONS + "go.png");
	btnUrl->setIcon(icon);
	btnUrl->setToolTip("Hiperlink");
	btnUrl->setGeometry( 210, 50, 30, 30 );

	QPushButton* btnH1 = new QPushButton(gbxBox);
	btnH1->setShortcut(Qt::CTRL + Qt::Key_1);
	icon.load((const QString&)DIR_ICONS + "h1.png");
	btnH1->setIcon(icon);
	btnH1->setToolTip("Ttulo 1");
	btnH1->setGeometry( 10, 90, 30, 30 );

	QPushButton* btnH2 = new QPushButton(gbxBox);
	btnH2->setShortcut(Qt::CTRL + Qt::Key_2);
	icon.load((const QString&)DIR_ICONS + "h2.png");
	btnH2->setIcon(icon);
	btnH2->setToolTip("Ttulo 2");
	btnH2->setGeometry( 50, 90, 30, 30 );

	QPushButton* btnH3 = new QPushButton(gbxBox);
	btnH3->setShortcut(Qt::CTRL + Qt::Key_3);
	icon.load((const QString&)DIR_ICONS + "h3.png");
	btnH3->setIcon(icon);
	btnH3->setToolTip("Ttulo 3");
	btnH3->setGeometry( 90, 90, 30, 30 );

	QPushButton* btnH4 = new QPushButton(gbxBox);
	btnH4->setShortcut(Qt::CTRL + Qt::Key_4);
	icon.load((const QString&)DIR_ICONS + "h4.png");
	btnH4->setIcon(icon);
	btnH4->setToolTip("Ttulo 4");
	btnH4->setGeometry( 130, 90, 30, 30 );

	QPushButton* btnH5 = new QPushButton(gbxBox);
	btnH5->setShortcut(Qt::CTRL + Qt::Key_5);
	icon.load((const QString&)DIR_ICONS + "h5.png");
	btnH5->setIcon(icon);
	btnH5->setToolTip("Ttulo 5");
	btnH5->setGeometry( 170, 90, 30, 30 );

	QPushButton* btnH6 = new QPushButton(gbxBox);
	btnH6->setShortcut(Qt::CTRL + Qt::Key_6);
	icon.load((const QString&)DIR_ICONS + "h6.png");
	btnH6->setIcon(icon);
	btnH6->setToolTip("Ttulo 6");
	btnH6->setGeometry( 210, 90, 30, 30 );

	QObject::connect(btnBold,SIGNAL(clicked() ),this, SLOT(clickedBold() ) );
	QObject::connect(btnItalic,SIGNAL(clicked() ),this, SLOT(clickedItalic() ) );
	QObject::connect(btnUnderline,SIGNAL(clicked() ),this, SLOT(clickedUnderline() ) );
	QObject::connect(btnLeft,SIGNAL(clicked() ),this, SLOT(clickedLeft() ) );
	QObject::connect(btnCenter,SIGNAL(clicked() ),this, SLOT(clickedCenter() ) );
	QObject::connect(btnRight,SIGNAL(clicked() ),this, SLOT(clickedRight() ) );
	QObject::connect(btnColor,SIGNAL(clicked() ),this, SLOT(clickedColor() ) );
	QObject::connect(btnBlockQuote,SIGNAL(clicked() ),this, SLOT(clickedBlockQuote() ) );
	QObject::connect(btnBList,SIGNAL(clicked() ),this, SLOT(clickedBList() ) );
	QObject::connect(btnOList,SIGNAL(clicked() ),this, SLOT(clickedOList() ) );
	QObject::connect(btnClear,SIGNAL(clicked() ),this, SLOT(clickedClear() ) );
	QObject::connect(btnUrl,SIGNAL(clicked() ),this, SLOT(clickedUrl() ) );
	QObject::connect(btnH1,SIGNAL(clicked() ),this, SLOT(clickedH1() ) );
	QObject::connect(btnH2,SIGNAL(clicked() ),this, SLOT(clickedH2() ) );
	QObject::connect(btnH3,SIGNAL(clicked() ),this, SLOT(clickedH3() ) );
	QObject::connect(btnH4,SIGNAL(clicked() ),this, SLOT(clickedH4() ) );
	QObject::connect(btnH5,SIGNAL(clicked() ),this, SLOT(clickedH5() ) );
	QObject::connect(btnH6,SIGNAL(clicked() ),this, SLOT(clickedH6() ) );
	
}
void WidgetEditor::clickedBold(){
	emit clickedFormato("[b]|[/b]");
}
void WidgetEditor::clickedItalic(){
	emit clickedFormato("[i]|[/i]");
}
void WidgetEditor::clickedUnderline(){
	emit clickedFormato("[u]|[/u]");
}
void WidgetEditor::clickedLeft(){
	emit clickedFormato("[left]|[/left]");
}
void WidgetEditor::clickedCenter(){
	emit clickedFormato("[center]|[/center]");
}
void WidgetEditor::clickedRight(){
	emit clickedFormato("[right]|[/right]");
}
void WidgetEditor::clickedColor(){
	QString cor =QColorDialog::getColor().name();
	emit clickedFormato("[color=\"" + cor +"\"]|[/color]");
}
void WidgetEditor::clickedBlockQuote(){
	emit clickedFormato("[blockquote]|[/blockquote]");
}
void WidgetEditor::clickedBList(){
	emit clickedFormato("[ul]\n\t[li]|[/li]\n[/ul]");
}
void WidgetEditor::clickedOList(){
	emit clickedFormato("[ol]\n\t[li]|[/li]\n[/ol]");
}
void WidgetEditor::clickedClear(){
	emit clickedFormato("clear");
}
void WidgetEditor::clickedUrl(){
	emit clickedFormato("[url=\"\"]|[/url]");
}
void WidgetEditor::clickedH1(){
	emit clickedFormato("[h1]|[/h1]");
}
void WidgetEditor::clickedH2(){
	emit clickedFormato("[h2]|[/h2]");
}
void WidgetEditor::clickedH3(){
	emit clickedFormato("[h3]|[/h3]");
}
void WidgetEditor::clickedH4(){
	emit clickedFormato("[h4]|[/h4]");
}
void WidgetEditor::clickedH5(){
	emit clickedFormato("[h5]|[/h5]");
}
void WidgetEditor::clickedH6(){
	emit clickedFormato("[h6]|[/h6]");
}

